﻿@page "/"
@using System.Text.RegularExpressions
@using Microsoft.AspNetCore.WebUtilities
@inject NavigationManager navMan
@inject Backend back
@inject Waiter wagter

<div style="text-align: center; margin-bottom: 32px;">
    <img src="assets/fsoc.png" style="max-height: 324px; max-width: 75vw;">

    <h1 class="h1">
        <span>Mankind</span><span style="font-size: .7em; color: darkorange;">.singularity.net.za</span>
    </h1>

    <p style="max-width: 564px; margin: auto;">
        Welcome to Mankind.wtf, the only online real-time multiplayer Cards Against Humanity cross-platform game service with attitude.
    </p>

</div>

@if (ExternalError != null) {
<div class="alert alert-danger" style="max-width: 846px; margin: 0 auto 14px;">
    <img src="assets/icons/exclamation-octagon.svg" height="32" width="32" class="text-danger">
    @ExternalError
</div>
}

<div class="card" style="max-width: 846px; margin: auto;">
        <div class="card-body">
            <ul class="nav nav-tabs" style="margin-bottom: 14px;">
                <li class="nav-item"><a href="#" class="@GetNavLinkClasses(0)" @onclick="()=>OnTabClick(0)">Create Game</a></li>
                <li class="nav-item"><a href="#" class="@GetNavLinkClasses(1)" @onclick="()=>OnTabClick(1)">Join Game</a></li>
                <li class="nav-item"><a href="#" class="@GetNavLinkClasses(2)" @onclick="()=>OnTabClick(2)">Suggest Cards</a></li>
            </ul>

            @if(TabIndex==0 || TabIndex==1){
                <div class="input-group" style="margin-bottom: 8px;">
                    <div class="input-group-prepend"><span class="input-group-text">Nickname:</span></div>
                    <input type="text" class="form-control" placeholder="Player1" aria-label="Nickname" disabled="@wagter.isBusy()"
                        @bind="InpNick">
                </div>
            }

            @if (TabIndex==0){
                <div style="display: flex;">
                    <div>
                        <SpinButton OnClickCallback="OnCreateGameClick" SpinningKey="awaitingCreateGame">Create Game</SpinButton>
                    </div>
                    @if (!wagter.isBusy() && CreateGameError != null) {
                        <div class="alert alert-danger" style="margin-left: 8px; padding: 6px;">
                            <img src="assets/icons/exclamation-octagon.svg" height="24" width="24" class="text-danger">
                            @CreateGameError
                        </div>
                    }
                </div>
            }

            @if (TabIndex==1) {
                <div class="input-group">
                    <div class="input-group-prepend"><span class="input-group-text">Game ID:</span></div>
                    <input type="text" class="form-control" placeholder="1234" aria-label="Game ID" disabled="@wagter.isBusy()"
                        @bind="InpGameId">
                </div>
                <div style="display: flex; margin-top: 8px;">
                    <div>
                        <SpinButton OnClickCallback="OnJoinGameClick" SpinningKey="awaitingJoinGame">Join Game</SpinButton>
                    </div>
                    @if (!wagter.isBusy() && JoinGameError != null) {
                        <div class="alert alert-danger" style="margin-left: 8px; padding: 6px;">
                            <img src="assets/icons/exclamation-octagon.svg" height="24" width="24" class="text-danger">
                            @JoinGameError
                        </div>
                    }
                </div>
            }

            @if (TabIndex==2){
                <button type="button" class="btn btn-link @sugDis(false)" @onclick="()=>suggestionQ=false">Response</button>
                <span>OR</span>
                <button type="button" class="btn btn-link @sugDis(true)" @onclick="()=>suggestionQ=true">Prompt</button>

                <div class="input-group" style="margin-top: 8px;">
                    <div class="input-group-prepend"><span class="input-group-text">Suggestion:</span></div>
                    <input type="text" class="form-control" placeholder="@sugPlaceholder()" aria-label="Suggestion" disabled="@wagter.isBusy()"
                        @bind="inpSuggestion">
                </div>
                <p>@if(suggestionQ){<span>Your prompt should allow noun responses. Use 6 underscores______ to indicate a blank.</span>}else{
                    <span>Make it a short noun-phrase or action.</span>
                }</p>


                <SpinButton OnClickCallback="OnSuggestCardClick" SpinningKey="awaitingSuggest">Suggest Card</SpinButton>
                @if (!wagter.isBusy() && sugResponse != null) {
                    <div class="alert alert-info" style="margin-top: 6px; padding: 6px;">
                        <img src="assets/icons/info-circle.svg" height="24" width="24" class="text-info">
                        @sugResponse
                    </div>
                }
            }
        </div>
    </div>

    <div style="margin: 108px auto auto 0; text-align: center;">
        <p>Game platform built by <a href="https://rauten.co.za">Jans Rautenbach</a></p>
        <p>Based on the party game <a href="https://cardsagainsthumanity.com/">Cards Against Humanity</a> <br/>
        (licensed under <a href="https://creativecommons.org/licenses/by-nc-sa/2.0/">Creative Commons BY-NC-SA 2.0</a>)</p>
    </div>

@code {
    private int TabIndex {get;set;} = 0;
    private bool suggestionQ {get;set;} = false;

    private string CreateGameError {get; set;} = null;
    private string JoinGameError {get; set;} = null;
    private string sugResponse {get;set;} = null;

    private string InpNick {get; set;} = "";
    private string InpGameId {get; set;} = "";
    private string inpSuggestion {get;set;} = "";

    private string ExternalError {get; set;} = null;

    protected override void OnInitialized(){

        // check if gameId is in the url query string
        var uri = navMan.ToAbsoluteUri(navMan.Uri);
        var parsed = QueryHelpers.ParseQuery(uri.Query);
        if (parsed.TryGetValue("gameId", out var gameId)){
            this.TabIndex = 1;
            this.InpGameId = gameId;
        }

        // check for external errors to report
        var err = back.PopWSError();
        if (err != null)
            this.ExternalError = err;

        // check if past nick still stored
        if (back.GetPlayerNick() != null){
            this.InpNick = back.GetPlayerNick();
        }
    }

    private string GetNavLinkClasses(int forTab) {
        return "nav-link" + (forTab==TabIndex ? " active" : "") +
            (wagter.isBusy() ? " disabled" : "");
    }

    private string sugDis(bool q){
        return suggestionQ == q ? "disabled" : "";
    }
    private string sugPlaceholder(){
        return suggestionQ ? "People love ______." : "Pineapple juice.";
    }

    private void OnTabClick(int tab){
        this.TabIndex = tab;
    }

    private async void OnCreateGameClick(){
        CreateGameError = null; ExternalError = null;
        InpNick = InpNick.Trim();
        if (InpNick.Length == 0){
            CreateGameError = "Please specify your nickname for the game";
            return;
        }
        if (!isAlphaNum(InpNick)){
            CreateGameError = "Nickname must contain letters and numbers only";
            return;
        }
        if (InpNick.Length > 16) {
            CreateGameError = "Nickname is too long";
            return;
        }

        wagter.SetState("awaitingCreateGame", true);

        try {
            var gameId = await back.CreateGame(InpNick);

            navMan.NavigateTo("/game/"+gameId);

        }catch (BadResponseException ex) {
            CreateGameError = ex.Message ?? "Unknown error";
        }

        wagter.SetState("awaitingCreateGame", false);
        base.StateHasChanged();
    }

    private async void OnJoinGameClick(){
        JoinGameError = null; ExternalError = null;
        InpNick = InpNick.Trim();
        InpGameId = InpGameId.Trim();
        if (InpNick.Length == 0){
            JoinGameError = "Please specify your nickname for the game";
            return;
        }
        if (!isAlphaNum(InpNick)){
            JoinGameError = "Nickname must contain letters and numbers only";
            return;
        }
        if (InpNick.Length > 20) {
            JoinGameError = "Nickname is too long";
            return;
        }
        if (InpGameId.Length == 0){
            JoinGameError = "Please specify the game ID";
            return;
        }
        if (!isNumeric(InpGameId)){
            JoinGameError = "Game ID should consist only of digits";
            return;
        }

        wagter.SetState("awaitingJoinGame", true);
        try {
            await back.RegisterToGame(InpNick, InpGameId);

            navMan.NavigateTo("/game/"+InpGameId);

        }catch (BadResponseException ex){
            JoinGameError = ex.Message ?? "Unkown error";
        }

        wagter.SetState("awaitingJoinGame", false);
        base.StateHasChanged();
    }

    private async Task OnSuggestCardClick(){
        if (inpSuggestion == ""){
            sugResponse = "Please input a suggestion.";
            return;
        }

        wagter.SetState("awaitingSuggest", true);
        await back.SuggestCard(inpSuggestion, suggestionQ);
        sugResponse = "Card suggested. It will be added to a deck after review.";
        inpSuggestion = "";
        wagter.SetState("awaitingSuggest", false);
        base.StateHasChanged();
    }

    private bool isAlphaNum(string text) {
        return Regex.IsMatch(text, "^[a-zA-Z0-9-_]*$");
    }

    private bool isNumeric(string text) {
        return Regex.IsMatch(text, "^[0-9]*$");
    }

}
